########### URL THiNGiE 2.1 ############
# designed and programmed by FlyBoyUSA  #
# for original use in #emuroms Undernet #
#########################################
# Thanks to guppy, BrainSick, Bass, KuRuPTioN, cHr|s, and VuDuCh|ld from #eggdrop 
# for helping me and CoolMikey from #emuroms for helping a little
# and anyone I forgot that gave me some input on this tcl
# BTW get Bass's seen script @ http://users.lazerlink.com/~bass/ it RULEZ!
# He helped me out alot :)
#
# Please send any comments, suggestions, death threats, marriage proposals, exploding
# cigars or bugs you find to flyboyus@modex.com
#
# If you are using an eggdrop below 1.3.x, please tell me if this script runs correctly
# and if you are running any TCL < 8.0 also please tell me, 7.6 should work.
#
# Also if you are using this script, please feel free to tell me you are and
# if you want I can inform you of new versions
#
# Changes for 1.1
# - Fixed it so you don't get the too many files open error
# - added FINDURL to search for entry's containing a word or phrase (wildcard's accepted)
#
# Changes for 1.2 (4/26/98)
# - Added FTP THiNGiE
# - fixed a few vocabulary mistakes and some other miscellaneous things
# - Changed it from UrL ThInGiE to URL THiNGiE (forgot who suggested it)
# - Probably some other things I cannot think of
#
# Changes for 1.3 (some time hehe)
# - Modified FINDURL to also search FTP
# - Added HELPURL that will list all the commands
# - DOH! Accidently had ADDURL and ADDFTP overwrite the entire file during a modification
#
# Changes for 2.0 (05/17/98)
# - Changed the entire TCL to mainly use arrays, much better
# - Added delurl and fixed the addurl and addftp modification
# - Data will be saved according to the hourly-updates variable from your config
# - Also fixed the * used in ADDFTP to work correctly (only noticed while editing tcl)
# - Uses barely any variables :-)
# - Using wildcards ? or * in geturl or getftp will do a search
# - Finnaly made up the help files... either copy them to your help directories or
#   let the script copy them for you
# - changed the syntax messages
# - added a variable that will let you set what access you need to modify urls
#
# Changes for 2.01 (05/22/98)
# - fixed problem with urlflag, didn't have it set as global
# - fixed a typing error in !addftp for public
# - sorry for releasing the fix so late been busy
#
# Changes for 2.1 (05/24/98)
# - changed the way URL THiNGiE runs, much more efficient
# - fixed it so findurl also searches the shortnames
# - ftp now only uses on line during getting an url
# - now if you add an ftp with no sitename it won't look retarded when getting it and such
# - maybe some other things, but I don't remember what
# - cut the file from 32k to 20k w00h00
#
# NOTE: Yes, I know my version numbers are probably the wrong way of numbering versions ;P

############################
# Variables you should set #
############################

# Set these to files to the files that will keep your data backed up
#  - directory starts in eggdrop directory
#  - a backup for the backup files are stored with an extra extension of ~bak
set urlfile "lamestbot.urls"
set ftpfile "lamestbot.ftps"

# Set this to theflag you want to be required for url deleting or modification
set urlflag "v"

# remove this next line or bot will not run
die "edit your URL THiNGiE config f00!"

############################################################
#     You should NOT modify anything below this line!      #
############################################################

if {![file exists ${help-path}urlftp.help]} {
     if {[file exists [file dirname [info script]]/urlftp.help]} {
          exec /bin/cp [file dirname [info script]]/urlftp.help ${help-path}
          putlog "DCC Help files copied to help directory"
     } {putlog "Could not copy dcc help files to directory due to error!"}
}

if {![file exists ${help-path}msg/urlftp.help]} {
     if {[file exists [file dirname [info script]]/urlftp.help.msg]} {
          exec /bin/cp [file dirname [info script]]/urlftp.help.msg ${help-path}/msg/urlftp.help
          putlog "MSG Help files copied to help directory"
     } {putlog "Could not copy msg help files to directory due to error!"}
}
if {[file exists ${help-path}msg/urlftp.help] || [file exists ${help-path}urlftp.help]} {loadhelp urlftp.help}

if {[array size urls] == 0 && [array size ftps] == 0} {
     putlog "Loading URL & FTP data..."
     global urlfile ftpfile
     if {[file exists $urlfile]} {
         set fd [open $urlfile r]
         while {![eof $fd]} {
               if {[eof $fd]} {return 0}
               set id [gets $fd]
               set urls([lindex $id 0]) "[lindex $id 1] [lrange $id 2 end]"
         }
         close $fd
     }
     if {[file exists $ftpfile]} {
         set fd [open $ftpfile r]
         while {![eof $fd]} {
               if {[eof $fd]} {return 0}
               set id [gets $fd]
               set ftps([lindex $id 0]) "[lindex $id 1] [lindex $id 2] [lindex $id 3] [lindex $id 4] [lrange $id 5 end]"
         }
         close $fd
     }
}

bind time - "${hourly-updates} * * * *" urlftp_filesave
proc urlftp_filesave {min hour day month year} {
     putlog "Writing URL and FTP data..."
     global urls ftps urlfile ftpfile
     if {[file exists $urlfile]} {
          exec /bin/mv -f $urlfile $urlfile~bak
     }
     if {[file exists $ftpfile]} {
          exec /bin/mv -f $ftpfile $ftpfile~bak
     }
     if {[info exists urls]} {
          set fd [open $urlfile w]
          set id [array startsearch urls]
          while {[array anymore urls $id]} {
               set temp [array nextelement urls $id]
               puts $fd "$temp $urls($temp)"
         }
         array donesearch urls $id
         close $fd
     }
     if {[info exists ftps]} {
          set fd [open $ftpfile w]
          set id [array startsearch ftps]
          while {[array anymore ftps $id]} {
               set temp [array nextelement ftps $id]
               puts $fd "$temp $ftps($temp)"
         }
         array donesearch ftps $id
         close $fd
     }
}

bind dcc - addurl *dcc:addurl
proc *dcc:addurl { hand idx arg } {
  if {[lrange $arg 2 end] == "" || [string match "HTTP:*" [lindex $arg 1]]} {
    putdcc $idx "Usage: addurl <one word shortname> <non-ftp url> <sitename>"
    return 0
  } {putdcc $idx "URL THiNGiE - [addurl $hand $arg]"
    return 1
  }
}

bind dcc - geturl *dcc:geturl
proc *dcc:geturl { hand idx arg } {
  if {$arg == ""} {
    putdcc $idx "Usage: geturl <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl dcc $idx $arg]
  } {putdcc $idx "URL THiNGiE - [geturl $arg]"
    return 1
  }
}

bind dcc $urlflag delurl *dcc:delurl
proc *dcc:delurl { hand idx arg } {
  if {$arg == ""} {
    putdcc $idx "Usage: delurl <one word shortname>"
    return 0
  } {putdcc $idx "URL THiNGiE - [delurl $arg]"
    return 1
  }
}

bind dcc - addftp *dcc:addftp
proc *dcc:addftp { hand idx arg } {
  if {[lindex $arg 0] == "" || [string match "FTP:*" [string toupper [lindex $arg 0]]]} {
    putdcc $idx "Usage: addftp <one word shortname> <ftp url> <userid> <password> <port> <sitename> (use * for defaults)"
    return 0
  } {putdcc $idx "FTP THiNGiE - [addftp $hand $arg]"
    return 1
  }
}

bind dcc - getftp *dcc:getftp
proc *dcc:getftp { hand idx arg } {
  if {$arg == ""} {
    putdcc $idx "Usage: getftp <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl dcc $idx $arg]
  } {putdcc $idx "URL THiNGiE - [getftp $arg]"
    return 1
  }
}

bind dcc $urlflag delftp *dcc:delftp
proc *dcc:delftp { hand idx arg } {
  if {$arg == ""} {
    putdcc $idx "Usage: delftp <one word shortname>"
    return 0
  } {putdcc $idx "FTP THiNGiE - [delftp $arg]"
    return 1
  }
}

bind dcc - findurl *dcc:findurl
proc *dcc:findurl { hand idx arg } {
  if {$arg == ""} {
    putdcc $idx "Usage: findurl <search phrase>"
    return 0
  } {return [findurl dcc $idx $arg]"
  }
}

bind msg - addurl *msg:addurl
proc *msg:addurl { nick uhost hand arg } {
  if {[lrange $arg 2 end] == "" || [string match "HTTP:*" [lindex $arg 1]]} {
    global botnick
    puthelp "NOTICE $nick :Usage: /msg $botnick addurl <one word shortname> <non-ftp url> <sitename>"
    return 0
  } {puthelp "NOTICE $nick :\002URL THiNGiE\002 - [addurl $hand $arg]"
    return 1
  }   
}

bind msg - geturl *msg:geturl
proc *msg:geturl { nick uhost hand arg } {
  global botnick
  set arg [string toupper $arg]
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: /msg $botnick geturl <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl msg $nick $arg]
  } {puthelp "NOTICE $nick :\002URL THiNGiE\002 - [geturl $arg]"
    return 1
  }
}

bind msg $urlflag delurl *msg:delurl
proc *msg:delurl { nick uhost hand arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: /msg $botnick delurl <one word shortname>"
    return 0
  } {puthelp "NOTICE $nick :\002URL THiNGiE\002 - [delurl $arg]"
    return 1
  }
}

bind msg - addftp *msg:addftp
proc *msg:addftp { nick uhost hand arg } {
  if {[lindex $arg 0] == "" || [string match "FTP:*" [string toupper [lindex $arg 0]]]} {
    puthelp "NOTICE $nick :Usage: /msg $botnick addftp <one word shortname> <ftp url> <userid> <password> <port> <sitename> (use * for defaults)"
    return 0
  } {puthelp "NOTICE $nick :\002FTP THiNGiE\002 - [addftp $hand $arg]"
    return 1
  }
}

bind msg - getftp *msg:getftp
proc *msg:getftp { nick uhost hand arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: /msg $botnick getftp <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl msg $nick $arg]
  } {puthelp "NOTICE $nick :\002URL THiNGiE\002 - [getftp $arg]"
    return 1
  }
}

bind msg $urlflag delftp *msg:delftp
proc *msg:delftp { nick uhost hand arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: /msg $botnick delftp <one word shortname"
    return 0
  } {puthelp "NOTICE $nick :\002FTP THiNGiE\002 - [delftp $arg]"
    return 1
  }
}

bind msg - findurl msg_findurl
proc msg_findurl { nick uhost hand arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: /msg $botnick findurl <search phrase>"
    return 0
  } {return [findurl msg $nick $arg]
  }
}

bind pub - !addurl *pub:addurl
bind pub - addurl *pub:addurl
proc *pub:addurl { nick uhost hand chan arg } {
  if {[lrange $arg 2 end] == "" || [string match "HTTP:*" [lindex $arg 1]]} {
    puthelp "NOTICE $nick :Usage: addurl <one word shortname> <non-ftp url> <sitename>"
    return 0
  } {puthelp "PRIVMSG $chan :\002URL THiNGiE\002 - [addurl $hand $arg]"
    return 1
  }        
}

bind pub - geturl *pub:geturl
bind pub - !geturl *pub:geturl
proc *pub:geturl { nick uhost hand chan arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: geturl <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl pub $chan $arg]
  } {puthelp "PRIVMSG $chan :\002URL THiNGiE\002 - [geturl $arg]"
    return 1
  }
}

bind pub $urlflag delurl *pub:delurl
bind pub $urlflag !delurl *pub:delurl
proc *pub:delurl { nick uhost hand chan arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: delurl <one word shortname>"
    return 0
  } {puthelp "PRIVMSG $chan :\002URL THiNGiE\002 - [delurl $arg]"
    return 1
  }
}

bind pub - addftp *pub:addftp
bind pub - !addftp *pub:addftp
proc *pub:addftp { nick uhost hand chan arg } {
  if {[lindex $arg 0] == "" || [string match "FTP:*" [string toupper [lindex $arg 0]]]} {
    puthelp "NOTICE $nick :Usage: addftp <one word shortname> <ftp url> <userid> <password> <port> <sitename> (use * for defaults)"
    return 0
  } {puthelp "PRIVMSG $chan :\002FTP THiNGiE\002 - [addftp $hand $arg]"
    return 1
  }
}

bind pub - getftp *pub:getftp
bind pub - !getftp *pub:getftp
proc *pub:getftp { nick uhost hand chan arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: getftp <one word shortname or search phrase>"
    return 0
  } elseif {[string match *\\\** $arg] || [string match *\\\?* $arg]} {return [findurl pub $chan $arg]
  } {puthelp "PRIVMSG $chan :\002FTP THiNGiE\002 - [getftp $arg]"
    return 1
  }
}

bind pub $urlflag delftp *pub:delftp
bind pub $urlflag !delftp *pub:delftp
proc *pub:delftp { nick uhost hand chan arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: delftp <one word shortname>"
    return 0
  } {puthelp "PRIVMSG $chan :\002FTP THiNGiE\002 - [delftp $arg]"
    return 1
  }
}

bind pub - findurl *pub:findurl
bind pub - !findurl *pub:findurl
proc *pub:findurl { nick uhost hand chan arg } {
  if {$arg == ""} {
    puthelp "NOTICE $nick :Usage: findurl <search phrase>"
    return 0
  } {return [findurl pub $chan $arg]
  }
}

proc addurl { hand arg } {
  global urls urlflag
  if {[lsearch -exact [array names urls] [string toupper [lindex $arg 0]]] > -1} {
    if {[matchattr $hand $urlflag]} {                  
      set urls([string toupper [lindex $arg 0]]) "[lindex $arg 1] [lrange $arg 2 end]"
      return [string toupper [lindex $arg 0]] modified to [lrange $arg 2 end] ([lindex $arg 1])"
    } {return There is already an url under that name and you don't have access to modify it!"}
  } {
    set urls([string toupper [lindex $arg 0]]) "[lindex $arg 1] [lrange $arg 2 end]"
    return "[lrange $arg 2 end] ([lindex $arg 1]) added under [string toupper [lindex $arg 0]]"
  }
}

proc geturl { arg } {
  global urls
  set arg [string toupper $arg]
  if {[info exists urls($arg)]} {return "URL for [lrange $urls($arg) 1 end] is [lindex $urls($arg) 0]"
  } {return "'$arg' NOT FOUND!"
  }
}

proc delurl { arg } {
  global urls botnick urlflag
  set arg [string toupper $arg]
  if {[info exists urls($arg)]} {
    set temp "('[lrange $urls($arg) 1 end]' ([lindex $urls($arg) 0]))"
    unset urls($arg)
    return "$arg deleted! $temp"
  } {return "'$arg' not found, unable to delete."
  }
}

proc addftp { hand arg } {
  global ftps urlflag
  set arg1 [lindex $arg 2]
  set arg2 [lindex $arg 3]
  set arg3 [lindex $arg 4]
  if {[lindex $arg 2] == "\*" || [lindex $arg 2] == ""} {set arg1 "anonymous"}
  if {[lindex $arg 3] == "\*" || [lindex $arg 3] == ""} {set arg2 "e-mail"}
  if {[lindex $arg 4] == "\*" || [lindex $arg 4] == ""} {set arg3 "21"}
  if {[info exists ftps([string toupper [lindex $arg 0]])]} {
    if {[matchattr $hand $urlflag $chan]} {
      set ftps([string toupper [lindex $arg 0]]) "[lindex $arg 1] $arg1 $arg2 $arg3 [lrange $arg 5 end]"
      if {[lrange $arg 5 end] == ""} {
        return "[string toupper [lindex $arg 0]] modified to [lindex $arg 1] with a l/p of $arg1/$arg2 on port $arg3"
      } {return "[string toupper [lindex $arg 0]] modified to [lrange $arg 5 end] ([lindex $arg 1]) with a l/p of $arg1/$arg2 on port $arg3"
      }
    } {return "There is already a ftp url under that name and you don't have access to modify it!"
    }
  } {set ftps([string toupper [lindex $arg 0]]) "[lindex $arg 1] $arg1 $arg2 $arg3 [lrange $arg 5 end]"
    if {[lrange $arg 5 end] == ""} {
      return "[lindex $arg 1] with a l/p of $arg1/$arg2 on port $arg3 added under [string toupper [lindex $arg 0]]"
    } {return "[lrange $arg 5 end] ([lindex $arg 1]) with a l/p of $arg1/$arg2 on port $arg3 added under [string toupper [lindex $arg 0]]"
    }
  }
}

proc getftp { arg } {
  global ftps
  set arg [string toupper $arg]
  if {[info exists ftps($arg)]} {
      if {[lrange $ftps($arg) 4 end] == ""} {
        return "URL is [lindex $ftps($arg) 0] with a l/p of [lindex $ftps($arg) 1]/[lindex $ftps($arg) 2] on port [lindex $ftps($arg) 3]"
      } {return "URL for [lrange $ftps($arg) 4 end] is [lindex $ftps($arg) 0] with a l/p of [lindex $ftps($arg) 1]/[lindex $ftps($arg) 2] on port [lindex $ftps($arg) 3]"
      }
  } {return "'$arg' NOT FOUND!"
  }
}

proc delftp { arg } {
  global ftps urlflag
  set arg [string toupper $arg]
  if {[info exists ftps($arg)]} {
    if {[lrange $ftps($arg) 4 end] == ""} {
      set temp [lindex $ftps($arg) 0]
      unset ftps($arg)
      return "$arg deleted! ($temp)"
    } {
      set temp "('[lrange $ftps($arg) 4 end]' ([lindex $ftps($arg) 0]))"
      unset ftps($arg)
      return "$arg deleted! $temp"
    }
  } {return "'$arg' not found, unable to delete."
  }
}

proc findurl { type target arg } {
  global urls ftps
  set arg [string toupper $arg]
  if {[info exists urls]} {
    set id [array startsearch urls]
    while {[array anymore urls $id]} {
      set temp [array nextelement urls $id]
      if {[string match "*$arg*" [string toupper $urls($temp)]] || [string match "*$arg*" $temp]} {append findlist(urls) "[lindex $temp 0] "}
    }
    array donesearch urls $id
  }
  if {[info exists ftps]} {
    set id [array startsearch ftps]
    while {[array anymore ftps $id]} {
      set temp [array nextelement ftps $id]
      if {[string match "*$arg*" [string toupper $ftps($temp)]] || [string match "*$arg*" $temp]} {append findlist(ftps) "[lindex $temp 0] "}
    }
    array donesearch ftps $id
  }
  if {![info exists findlist(urls)] && ![info exists findlist (ftps)]} {
    switch $type {
      dcc {putdcc $target "FTP & URL THiNGiE - Nothing matching '$arg' found!"
        return 1}
      msg {puthelp "NOTICE $target :\002FTP & URL THiNGiE\002 - Nothing matching '$arg' found!"
        return 1}
      pub {puthelp "PRIVMSG $target :\002FTP & URL THiNGiE\002 - Nothing matching '$arg' found!"
        return 1}
    }
  } elseif {[info exists findlist(urls)] && [info exists findlist(ftps)]} {
    switch $type {
      dcc {putdcc $target "URL THiNGiE - $findlist(urls)"
        putdcc $target "FTP THiNGiE - $findlist(ftps)"
        return 1}
      msg {puthelp "NOTICE $target :\002URL THiNGiE\002 - $findlist(urls)"
        puthelp "NOTICE $target :\002FTP THiNGiE\002 - $findlist(ftps)"
        return 1}
      pub {puthelp "PRIVMSG $target :\002URL THiNGiE\002 - $findlist(urls)"
        puthelp "PRIVMSG $target :\002FTP THiNGiE\002 - $findlist(ftps)"
        return 1}
    }
  } elseif {[info exists findlist(urls)]} {
    if {[lindex $findlist(urls) 1] == ""} {
      switch $type {
        dcc {putdcc $target "URL THiNGiE - [geturl [lindex $findlist(urls) 0]]"
          return 1}
        msg {puthelp "NOTICE $target :\002URL THiNGiE\002 - [geturl [lindex $findlist(urls) 0]]"
          return 1}
        pub {puthelp "PRIVMSG $target :\002URL THiNGiE\002 - [geturl [lindex $findlist(urls) 0]]"
          return 1}
      }
    } {switch $type {
        dcc {putdcc $target "URL THiNGiE - $findlist(urls)"
          return 1}
        msg {puthelp "NOTICE $target :\002URL THiNGiE\002 - $findlist(urls)"
          return 1}
        pub {puthelp "PRIVMSG $target :\002URL THiNGiE\002 - $findlist(urls)"
          return 1}
      }
    }
  } {if {[lindex $findlist(ftps) 1] == ""} {
      switch $type {
        dcc {putdcc $target "FTP THiNGiE - [getftp [lindex $findlist(ftps) 0]]"
          return 1}
        msg {puthelp "NOTICE $target :\002FTP THiNGiE\002 - [getftp [lindex $findlist(ftps) 0]]"
          return 1}
        pub {puthelp "PRIVMSG $target :\002FTP THiNGiE\002 - [getftp [lindex $findlist(ftps) 0]]"
          return 1}
      }
    } {switch $type {
        dcc {putdcc $target "FTP THiNGiE - $findlist(ftps)"
          return 1}
        msg {puthelp "NOTICE $target :\002FTP THiNGiE\002 - $findlist(ftps)"
          return 1}
        pub {puthelp "PRIVMSG $target :\002FTP THiNGiE\002 - $findlist(ftps)"
          return 1}
      }
    }
  }
}

putlog "=__ URL THiNGiE 2.1 by FlyBoyUSA Loaded __="
